# -*- coding: utf-8 -*-
"""
Created on Tue Apr 15 10:52:10 2014

@author: ben
"""

from pylab import *
from numpy import *
from PIL import Image
import cv2
from matplotlib import pyplot as PLT
import StringIO
import PIL

# If you have PCV installed, these imports should work
from PCV.geometry import homography, camera
#from PCV.localdescriptors import sift
from PCV.localdescriptors import sift

"""
This is the augmented reality and pose estimation cube example from Section 4.3.
"""



mysift = cv2.SIFT(400)
img0 = cv2.imread('Images/imageTest1.1.jpg',cv2.COLOR_BGR2GRAY)
#print img0
l0, d0 = mysift.detectAndCompute(img0,None)
im = cv2.drawKeypoints(img0,l0,flags=cv2.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS)
cv2.imwrite("ble.jpg",im)
kp = l0
l0=np.asarray([ [i.pt[0],i.pt[1]] for i in l0]) #convert to array([[x0,y0],[x1,y1],...])
img1 = cv2.imread('Images/imageTest1.2.jpg',cv2.COLOR_BGR2GRAY)
l1, d1 = mysift.detectAndCompute(img1,None)
temp = cv2.drawKeypoints(img1,l1,flags=cv2.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS)
kp2 = l1
l1=np.asarray([ [i.pt[0],i.pt[1]] for i in l1]) #convert to array([[x0,y0],[x1,y1],...])


#match features and estimate homography
matches = sift.match_twosided(d0,d1)
ndx = matches.nonzero()[0]
fp = homography.make_homog(l0[ndx,:2].T) 
ndx2 = [int(matches[i]) for i in ndx]
tp = homography.make_homog(l1[ndx2,:2].T)

model = homography.RansacModel()
H, inliers = homography.H_from_ransac(fp,tp,model) 

M=H[:2,:2]
T=H[:2,2]
#print Homography
print "\nMatrice rotation-homothetie:\n",M
print "\nMatrice translation:\n", T
print "\nMatrice homography",H

# Draw Keypoints: 
h1, w1 = im.shape[:2]
h2, w2 = temp.shape[:2]
nWidth = w1+w2
nHeight = max(h1, h2)
hdif = (h1-h2)/2
newimg = zeros((nHeight, nWidth, 3), uint8)
newimg[hdif:hdif+h2, :w2] = temp
newimg[:h1, w2:w1+w2] = im


# draw lines joining matched points.
for i in range(min(len(kp2), len(kp))):
    pt_a = (int(kp2[i].pt[0]), int(kp2[i].pt[1]+hdif))
    pt_b = (int(kp[i].pt[0]+w2), int(kp[i].pt[1]))
    cv2.line(newimg, pt_a, pt_b, (255, 0, 0))


cv2.imshow("image", newimg)
#imsave("imageTest3.jpg",newimg)
cv2.waitKey(0)
    
#show()